Entwurf Orthogonales (rechtwinkliges) Feld

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Draft OrthoArray and the translation is 59% complete.
Other languages:
Deutsch • ‎English • ‎français • ‎italiano • ‎русский

Draft OrthoArray.svg Entwurf AnordnungRechtwinklig

Menüeintrag
Modifikation → Anordnung Werkzeuge → Anordnung
Arbeitsbereich
Entwurf
Standardtastenkürzel
None
In der Version eingeführt
0.19
Siehe auch
Entwurf PolaresFeld, Entwurf KreisAnordnung, Entwurf PfadAnordnung, Entwurf Punktefeld, Entwurf Klonen


Beschreibung

Das Draft OrthoArray.svg Entwurf AnordnungRechtwinklig Werkzeug erstellt eine orthogonale (3 Achsen) Anordnung aus einem ausgewählten Objekt.

Dieses Werkzeug kann für jedes Objekt verwendet werden, das eine Part TopoForm hat, d.h. 2D Formen, die mit der Entwurf Arbeitsbereich erstellt wurden, aber auch 3D Körper, die mit anderenArbeitsbereichen erstellt wurden, z.B. Part, PartDesign oder Arch. Statt einfacher Kopien können auch AnwendungsVerknüpfungen erstellt werden.

  • Über die Draft PolarArray.svg Polares Feld-Schaltfläche und Draft CircularArray.svg Kreisanordnungswerkzeugen können polare Felder oder Kreisfelder erzeugt werden.
  • Mit den Draft PathArray.svg Pfadfeld oder Draft PathLinkArray.svg PathLinkArray-Schaltflächen können Kopien entlang eines Pfades positioniert werden.
  • Mit den Draft PointArray.svg Punktefeld oder Draft PointLinkArray.svg PointLinkArray-Schaltflächen können Kopien an speziellen Punkten positioniert werden.
  • Mit den Draft Move.svg Verschieben oder Draft Rotate.svg Drehen-Schaltflächen können Kopien erzeugt und manuell positioniert werden.
  • Mit den Draft Clone.svg Klone- oder Std LinkMake.svg Std LinkMake-Schaltflächen können exakte Kopien erzeugt und manuell positioniert und skaliert werden.

Dieser Befehl ersetzt den ehemaligen Draft Array.svg Feld Befehl, wie auch die nur kurze Zeit existierten Draft LinkArray.svg LinkArray Werkzeuge.

Draft Array example.png

Orthogonales Feld (array) eines Festkörpers.


Anwendung

  1. Das zu vervielfältigende Objekt wählen.
  2. Die Draft OrthoArray.svg Entwurf AnordungRechtwinklig-Schaltfläche beätigen. Wurde kein Objekt ausgewählt, erscheint eine Aufforderung dazu.
  3. Der Aufgabenreiter wird angezeigt, in dem die Anzahl der Elemente in X, Y und Z-Richtung und der Abstand zueinander bestimmt werden kann.
  4. Mit einem Klick in die 3D-Ansicht können Anzahl und Abstände eingestellt und der Befehl abgeschlossen werden. Ansonsten kann mit Enter oder OK der Befehl abgeschlossen werden.

Hinweise

  • Jedes Element im Feld ist eine exakte Kopie des Originals, aber das geasamte Feld wird als eine einzige Einheit mit ihren Eigenschaften und ihrer Erscheinung angesehen.
  • Dieser Befehl erzeugt das gleiche "Feld"objekt, wie das, das mit den Draft PolarArray.svg Polares Feld und Draft CircularArray.svg Kreisfeld-Werkeugen erstellt wurde. Deshalb kann das Feld von orthogonal in polar oder kreisförmig durch seinen DataFeldtyp umgewandelt werden.

Optionen

Dies sind die Möglichkeiten im Aufgaben Reiter.

  • Number of elements: the elements in the X, Y, and Z directions. A copy of the original object is always produced, so this number must be at least 1 in every direction.
  • X intervals: the values of displacement for the copies in the X direction. To create strictly rectangular arrays, the Y and Z values should be zero (x, 0, 0).
  • Y intervals: the values of displacement for the copies in the Y direction. To create strictly rectangular arrays, the X and Z values should be zero (0, y, 0).
  • Z intervals: the values of displacement for the copies in the Z direction. To create strictly rectangular arrays, the X and Y values should be zero (0, 0, z).
  • Reset X, Y, Z: it resets the interval vectors to a rectangular displacement, that is (x, 0, 0), (0, y, 0), and (0, 0, z).
  • Fuse: if it is checked, the resulting objects in the array will fuse together if they touch each other. This only works if Link array is unchecked.
  • Link array: if it is checked, the resulting array will be a "Link array". This array internally uses App Link objects, so it is more efficient when handling many copies of complex shapes. However, in this case, the objects cannot be fused together.
  • Press Esc or the Cancel button to abort the current command.

Note: if a Link array is created, this object cannot be converted to a regular array. And similarly, a regular array cannot be converted to a Link array. Therefore, you must choose the type of array that you want at creation time.

Eigenschaften

An OrthoArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the OrthoArray has the following properties in the property editor.

Objects

  • DataArray Type (Enumeration): specifies the type of array to create, "ortho", "polar", or "circular".
  • DataAxis Reference (LinkGlobal): specifies the object and edge that can be used as reference for polar and circular arrays; for example, it can be the edge of a Draft Wire.svg Wire or a PartDesign Line.svg PartDesign DatumLine. If this property exists, it overrides both DataAxis and DataCenter, for polar and circular arrays.
  • DataBase (Link): specifies the object to duplicate in the array.
  • DataFuse (Bool): it defaults to false; if it is true, and the copies intersect with each other, they will be fused together into a single shape. This only works if the initial array was not a "Link array".

Orthogonal array

  • DataInterval X (VectorDistance): a vector specifying the interval between each copy on the X axis.
  • DataInterval Y (VectorDistance): a vector specifying the interval between each copy on the Y axis.
  • DataInterval Z (VectorDistance): a vector specifying the interval between each copy on the Z axis.
  • DataNumber X (Integer): the number of copies on the X direction. The DataBase object counts as one copy; it must be at least 1.
  • DataNumber Y (Integer): the number of copies on the Y direction.
  • DataNumber Z (Integer): the number of copies on the Z direction.

Polar/circular array

  • DataAxis (Vector): the axis direction around which the elements in a polar or circular array are created.
  • DataCenter (VectorDistance): specifies the center point of the polar or circular array. The DataAxis passes through this point. For circular arrays, the DataCenter specifies an offset from the DataPlacement of the DataBase object.

Polar array

  • DataAngle (Angle): specifies the aperture of the circular arc to cover with copies; use 360 to cover an entire circle.
  • DataInterval Axis (VectorDistance): distance and orientation of each copy in DataAxis direction.
  • DataNumber Polar (Integer): number of copies in the polar direction.

Circular array

  • DataNumber Circles (Integer): the number of circular layers to create. The DataBase object counts as one layer; it must be at least 1.
  • DataRadial distance (Distance): the distance between circular layers.
  • DataSymmetry (Integer): a number that indicates the symmetry lines in the circular layers. This number changes the distribution of the objects and making it very large may eliminate the more central layers.
  • DataTangential Distance (Distance): the distance between copies in the same circular layer.

Felder verknüpfen

In addition to the previous properties, these properties only appear when the array is created as a Link array.

Objects

  • DataCount (Integer): (read-only) it is the total number of objects in the array including the original object. This property is read-only as the value depends on the other "Number" properties, whether they are orthogonal, polar, or circular.
  • DataExpand Array (Bool): if it is true, the individual App Link objects will be available to select in the tree view.

Link

  • DataScale (Float): the scale factor of the entire array.
  • DataScale List (VectorList): a list of N-vectors determining the individual scaling factor of each of the N-elements in the array, where N is DataCount.
  • DataLink Transform (Bool): if it is false it can override the linked object's placement.

Hinweise

The "Number" properties, whether for orthogonal, polar, or circular arrays, includes the original object, so this value must be at least one.

An interval is not a simple distance, but a vector (x, y, z). If more than one value is non-zero, the copy will be created in the main direction, but will also be displaced in the other non-zero directions.

For example, if DataInterval X is (2 m, 1 m, 1 m), and DataNumber X is 3, it will create 3 copies in the X direction; the first copy will be at the original position, the second will be displaced 2 m on X, 1 m on Y, and 1 m on Z; the third copy will be displaced 4 m on X, 2 m on Y, and 2 m on Z. Each array element will be moved slightly to one side (Y direction) and up (Z direction) beside the main X direction.

The DataInterval Axis property works in the same way. If the original shape lies on the XY plane, creating a polar array with DataInterval Axis (0, 0, z) allows you to make spiral arrangements, as each copy will be moved a z distance.

Konfiguration individueller Verknüpfungen

Normally, App Link objects are intended to be exact copies of their DataLinked Object. However, there is a pending feature that will allow configuring individual properties of select App Link copies; this could be useful for Link Arrays. This feature is called a "configuration table".

Skripten

Siehe auch: Draft API und FreeCAD Grundlagen Skripten.

Das Werkzeug AnordnungRechtwinklig kann in Makros und von der Python Konsole aus mit folgender Funktion verwendet werden:

Alter Aufruf:

array = makeArray(baseobject, xvector, yvector, zvector, xnum, ynum, znum, use_link=False)

Neuer Aufruf:

array = make_ortho_array(base_object,
                         v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0), v_z=App.Vector(0, 0, 10),
                         n_x=2, n_y=2, n_z=1,
                         use_link=True)
array = make_ortho_array2d(base_object,
                           v_x=App.Vector(10, 0, 0), v_y=App.Vector(0, 10, 0),
                           n_x=2, n_y=2,
                           use_link=True)
  • Creates an "Array" object from the base_object.
    • Instead of a reference to an object, base_object can also be the Label (string) of an object existing in the current document.
    • The vectors v_x, v_y, and v_z determine the distance between the base points of each copy, in the X, Y, and Z directions; and n_x, n_y, and n_z are the number of copies in the respective direction.
    • If use_link is True, the type of array created will be a Link array, whose elements are App Link instances instead of simple copies.
    • make_ortho_array2d ignores the Z component, so the result is going to be a 2D array in the XY plane.
array = make_rect_array(base_object,
                        d_x=10, d_y=10, d_z=10,
                        n_x=2, n_y=2, n_z=1,
                        use_link=True)
array = make_rect_array2d(base_object,
                          d_x=10, d_y=10,
                          n_x=2, n_y=2,
                          use_link=True)
  • The _rect_ variants ignore the off-diagonal components of the v_x, v_y, and v_z vectors, so the arrays will be completely rectangular; the distance between the elements is determined by d_x, d_y, and d_z.

Beispiel:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.make_ortho_array2d(rect, v_x, v_y, 3, 4)
doc.recompute()

Skripten, nicht-parametrische Anordnung

When using the Draft OrthoArray.svg OrthoArray tool, a parametric "Array" object is created. This can be scripted as described in the previous section.

However, to obtain standalone copies of the base object, the simple Draft.array function can be used. This will create simple copies, not a new parametric object.

Um ein rechtwinkliges Feld zu erzeugen, wird es so verwendet:

array_list = array(objectslist, xvector, yvector, xnum, ynum)
array_list = array(objectslist, xvector, yvector, zvector, xnum, ynum, znum)
  • Creates an array from the objects contained in objectslist, which can be a single object or a list of objects.
    • In case of a rectangular array, xvector, yvector, and zvector determine the distance between the base points of each copy, in the X, Y, and Z directions; and xnum, ynum, and znum are the number of copies in the respective direction.
    • array_list is returned with the new copies. It is either a single object or a list of objects, depending on the input objectslist.

Diese Funktion verwendet intern Draft.move() mit copy=True.

Beispiel:

import FreeCAD as App
import Draft

doc = App.newDocument()

rect = Draft.make_rectangle(1500, 500)
v_x = App.Vector(1600, 0, 0)
v_y = App.Vector(0, 600, 0)

array = Draft.array(rect, v_x, v_y, 3, 4)
doc.recompute()